.386
.MODEL FLAT

.CODE
_run:

include         stdparas.inc                            ; PA1-PA4
include         abpstruc.inc                            ; asmBmpPara-structure


; *********************************************************************************************

asmBmpPara      EQU     <PA1>
fct             EQU     <PA2>                           ; factor 0 to 255
flg             EQU     <PA3>                           ; Bit 7: Mode 2
                                                        ; Bit 6: Mode 1
                                                        ; Bit 0: b/w
buf             EQU     <PA4>                           ; buffer for replacement table

; *********************************************************************************************

Neon            PROC    NEAR

init:           mac     SAVE
                push    71                              ; => stack1   = red factor
                push    707                             ; => stack2   = green factor
                push    222                             ; => stack3   = blue factor
                push    1000                            ; => stack4   = divisor
                         
                push    3F993B36h                       ; => stack5/6 = 1/255*Pi*2
                push    8ACEFC0Fh                       ;             = 0.0246399423810964

                push    405FC000h                       ; => stack7/8 = 127
                push    0
                                

                mov     edi,buf                         ; create replacement table
                fld     QWord Ptr [ebp-stOf6]
                fld     QWord Ptr [ebp-stOf8]

                mov     edx,flg
                mov     dh,dl
                shl     dl,1
                and     dl,80h

                mov     ecx,0FFh
                mov     ebx,fct
                and     ebx,ecx

tab_loop:       push    ebx                             ; stack9       
                fild    stack9
                fmul    st(0),st(2)
                fcos
                fmul    st(0),st(1)                     ; st(0) = cos(fct*(1/255*Pi*2))*127
                test    dh,0C0h
                jnz     tab_loop_1
                fsub    st(0),st(1)
tab_loop_1:     fabs
                fistp   stack9
                pop     eax                             ; eax   = int(abs(st(0)))
                or      al,dl
                mov     [edi],al
                inc     edi
                inc     bl
                dec     ecx
                jns     tab_loop

                fstp    st(1)                           ; clear x87 registers
                fstp    stack6


                mov     ebx,asmBmpPara                  ; initialize loop
                mov     esi,srcBits
                mov     edi,tgtBits
                mov     edx,tgtHeight
                mov     ecx,tgtWidth
                mov     ebx,buf

row_loop:       push    ecx                             ; change pixels
col_loop:       lodsd
                add     al,dl
                xlat
                ror     eax,8
                sub     al,cl
                xlat
                ror     eax,8
                add     al,dl
                xlat
                ror     eax,16
                test    flg,1
                jz      col_loop_1 

                push    edx                             ; b/w conversion
                mov     edx,eax
                movzx   eax,al
                imul    eax,stack1
                push    eax
                shr     edx,8
                movzx   eax,dl
                imul    eax,stack2
                push    eax
                movzx   eax,dh
                imul    eax,stack3
                pop     edx
                add     eax,edx
                pop     edx
                add     eax,edx
                cdq
                div     stack4
                mov     ah,al
                shl     eax,8
                mov     al,ah                
                pop     edx
col_loop_1:     stosd
                dec     ecx
                jnz     col_loop

                pop     ecx                
                dec     edx
                jnz     row_loop
                
finish:         stc
                mac     RESTSP

Neon            ENDP

END _run
